src/Entity/Cotisation.php
<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use App\Repository\CotisationRepository;
use ApiPlatform\Core\Annotation\ApiResource;

/**
 * ApiResource()
 * @ORM\Entity(repositoryClass=CotisationRepository::class)
 */
class Cotisation
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $libelleCotisation;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $typeCotisation;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $anneeCotisation;

    /**
     * @ORM\Column(type="integer")
     */
    private $prixCotisation;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="cotisations")
     */
    private $users;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $MoyenDePaiement;


    private $vads_amount;
    private $vads_action_mode;
    private $vads_capture_delay;
    private $ctx_mode;
    private $vads_currency;
    private $vads_page_action;
    private $vads_payment_cards;
    private $vads_payment_config;
    private $vads_site_id;
    private $vads_trans_date;
    private $vads_trans_id;
    private $vads_version;
    private $signature;
    private $certificate;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLibelleCotisation(): ?string
    {
        return $this->libelleCotisation;
    }

    public function setLibelleCotisation(string $libelleCotisation): self
    {
        $this->libelleCotisation = $libelleCotisation;

        return $this;
    }

    public function getTypeCotisation(): ?string
    {
        return $this->typeCotisation;
    }

    public function setTypeCotisation(string $typeCotisation): self
    {
        $this->typeCotisation = $typeCotisation;

        return $this;
    }

    public function getAnneeCotisation(): ?string
    {
        return $this->anneeCotisation;
    }

    public function setAnneeCotisation(string $anneeCotisation): self
    {
        $this->anneeCotisation = $anneeCotisation;

        return $this;
    }

    public function getPrixCotisation(): ?int
    {
        return $this->prixCotisation;
    }

    public function setPrixCotisation(int $prixCotisation): self
    {
        $this->prixCotisation = $prixCotisation;

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->users;
    }

    public function setUser(?User $user): self
    {
        $this->users = $user;

        return $this;
    }

    public function __toString(): string
    {
        return (string) $this->getLibelleCotisation();
    }

    public function getMoyenDePaiement(): ?string
    {
        return $this->MoyenDePaiement;
    }

    public function setMoyenDePaiement(string $MoyenDePaiement): self
    {
        $this->MoyenDePaiement = $MoyenDePaiement;

        return $this;
    }

    public function getVadsAmount(): ?string
    {
        return $this->getPrixCotisation();
    }

    public function getVadsActionMode(): ?string
    {
        return "INTERACTIVE";
    }
    public function getVadsCaptureDelay(): ?string
    {
        return "0";
    }

    public function getCtxMode(): ?string
    {
        return "TEST";
    }

    public function getVadsCurrency(): ?string
    {
        return "978";
    }

    public function getVadsPageAction(): ?string
    {
        return "PAYMENT";
    }

    public function getVadsPaymentCards(): ?string
    {
        return "CB";
    }

    public function getVadsPaymentConfig(): ?string
    {
        return "SINGLE";
    }

    public function getVadsSiteId(): ?string
    {
        return "20169455";
    }

    public function getVadsTransDate(): ?string
    {
        return gmdate('YmdHis');
    }

    public function getVadsTransId(): ?string
    {
        return substr(time(), -6);
    }

    public function getVadsVersion(): ?string
    {
        return "V2";
    }

    public function getCertificate(): ?string
    {
        return "rQ1dYFoUrLsTCfdr";
    }

    public function getSignature(): ?string
    {
        $signature_content = $this->getVadsActionMode().'+'.
        strval($this->getVadsAmount()*100).'+'.
        //$this->getVadsCaptureDelay().'+'.
        $this->getCtxMode().'+'.
        strval($this->getVadsCurrency()).'+'.
        $this->getVadsPageAction().'+'.
        $this->getVadsPaymentConfig().'+'.
        strval($this->getVadsSiteId()).'+'.
        strval($this->getVadsTransDate()).'+'.
        strval($this->getVadsTransId()).'+'.
        $this->getVadsVersion();
        $signature_content .= '+'.$this->getCertificate();
        $signature = base64_encode(hash_hmac('sha256',$signature_content, $this->getCertificate(), true));
        return $signature;
    }

    public function getUsers(): ?User
    {
        return $this->users;
    }

    public function setUsers(?User $users): self
    {
        $this->users = $users;

        return $this;
    }

}

src/Form/CotisationType.php
<?php

namespace App\Form;

use App\Entity\Cotisation;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;

class CotisationType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('libelleCotisation', TextType::class)
            ->add('typeCotisation',  TextType::class)
            ->add('anneeCotisation',  TextType::class)
            ->add('prixCotisation', IntegerType::class)
            ->add('valider', SubmitType::class)
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Cotisation::class,
        ]);
    }
}

src/Controller/Admin/CotisationController.php
<?php

namespace App\Controller\Admin;

use Monolog\Logger;
use Twig\Environment;
use App\Entity\Cotisation;
use App\Form\CotisationType;
use Monolog\Handler\StreamHandler;
use Monolog\Handler\FirePHPHandler;
use App\Form\CotisationAdherentType;
use App\Repository\CotisationRepository;
use Lyra\PayzenBundle\Payzen\PayzenService;
use Symfony\Component\HttpClient\HttpClient;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Lyra\PayzenBundle\Includes\PayzenParamsUrl;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpClient\Response\CurlResponse;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\ParamConverter;


/**
 * @IsGranted("ROLE_ADMIN")
 * @Route("/admin/cotisation", name="admin_cotisation_")
 * @package App\Controller\Admin
 */
class CotisationController extends AbstractController
{
    #[Route('/', name: 'home')]
    public function index(CotisationRepository $cotisation): Response
    {
        return $this->render('Admin/cotisation/index.html.twig', [
            'cotisations' => $cotisation->findAll(),
        ]);
    }
    /**
     * @Route("/{id}", name="show", requirements={"id":"\d+"})
     */
    public function show(Environment $twig, Cotisation $cotisation, CotisationRepository $cotisationRepository): Response
    {
        return new Response($twig->render('admin/cotisation/show.html.twig', [
            'cotisation' => $cotisation,
        ]));
    }

    #[Route('/ajout', name: 'ajout')]
    public function new(Request $request): Response
    {
        $cotisation = new Cotisation;

        $form = $this->createForm(CotisationType::class, $cotisation);

        $form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid()){
            $em = $this->getDoctrine()->getManager();
            $em->persist($cotisation);
            $em->flush();

            return $this->redirectToRoute('admin_cotisation_home');
        }

        return $this->render('admin/cotisation/ajout.html.twig', [
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/cotisation/paiement/{id}", name="paiement_cotisation", methods = {"GET", "POST"})
     * 
    */
    public function paiementCotisation(Request $request, Cotisation $cotisation)
    {
        //$client = new HttpClientInterface();
        $httpClient = HttpClient::create();
        $form = $this->createForm(CotisationAdherentType::class, $cotisation);

        $form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid()){

            $cotisation->setUser($this->getUser());
            $moyen = $form->getData()->getMoyenDePaiement();
            $cotisation->setMoyenDePaiement($moyen);
            $data = $form->getData();
            $prix = $cotisation->getPrixCotisation()*100;
            $em = $this->getDoctrine()->getManager();
            $em->persist($cotisation);
            $em->flush();
            $response = new Response();
            //$response = new CurlResponse();
            $actionMode = $cotisation->getVadsActionMode();
            //$captureDelay = $cotisation->getVadsCaptureDelay();
            $ctxMode = $cotisation->getCtxMode();
            $currency = $cotisation->getVadsCurrency();
            $pageAction = $cotisation->getVadsPageAction();
            //$paymentCards = $cotisation->getVadsPaymentCards();
            $paymentConfig = $cotisation->getVadsPaymentConfig();
            $siteId = $cotisation->getVadsSiteId();
            $transDate = $cotisation->getVadsTransDate();
            $transId = $cotisation->getVadsTransId();
            $version = $cotisation->getVadsVersion();
            //$certificate = $cotisation->getCertificate();
            $signature = $cotisation->getSignature();
            return $response = $httpClient->request('POST', 'https://paiement.systempay.fr/vads-payment/', [
                'body' => [
                    'vads_action_mode' =>  $actionMode,
                    'vads_amount' => $prix,
                    //'vads_capture_delay' => $captureDelay,
                    'vads_ctx_mode' => $ctxMode,
                    'vads_currency' => $currency,
                    'vads_page_action' => $pageAction,
                    //'vads_payment_cards' => $paymentCards,
                    'vads_payment_config' => $paymentConfig,
                    'vads_site_id' => $siteId,
                    'vads_trans_date' => $transDate,
                    'vads_trans_id' => $transId,
                    'vads_version' => $version,
                    //'vads_certificate' => $certificate,
                    'signature' => $signature
                ]
            ]);
            //echo $response->getContent();
        }

        return $this->render('Admin/cotisation/paiement.html.twig', [
            'form' => $form->createView(),
        ]);
    }

}

src/Controller/CotisationController.php
<?php

namespace App\Controller;

use Monolog\Logger;
use Twig\Environment;
use App\Entity\Cotisation;
use Monolog\Handler\StreamHandler;
use Monolog\Handler\FirePHPHandler;
use App\Form\CotisationAdherentType;
use App\Repository\CotisationRepository;
use Lyra\PayzenBundle\Payzen\PayzenService;
use Symfony\Component\HttpClient\HttpClient;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Lyra\PayzenBundle\Includes\PayzenParamsUrl;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpClient\Response\CurlResponse;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\ParamConverter;

class CotisationController extends AbstractController
{
    #[Route('/cotisation', name: 'cotisation')]
    public function index(CotisationRepository $cotisation): Response
    {
        return $this->render('cotisation/index.html.twig', [
            'cotisations' => $cotisation->findAll(),
        ]);
    }

   #[Route('/cotisation/{id}', name: 'cotisation_show')]
    public function show(Environment $twig, Cotisation $cotisation, CotisationRepository $cotisationRepository): Response
    {
        return new Response($twig->render('cotisation/show.html.twig', [
            'cotisation' => $cotisation,
        ]));
    }

    /**
     * @Route("/cotisation/paiement/{id}", name="paiement_cotisation", methods = {"GET", "POST"})
     * 
    */
    public function paiementCotisation(Request $request, Cotisation $cotisation)
    {
        //$client = new HttpClientInterface();
        $httpClient = HttpClient::create();
        $form = $this->createForm(CotisationAdherentType::class, $cotisation);

        $form->handleRequest($request);

        if($form->isSubmitted() && $form->isValid()){

            $cotisation->setUser($this->getUser());
            $moyen = $form->getData()->getMoyenDePaiement();
            $cotisation->setMoyenDePaiement($moyen);
            $data = $form->getData();
            $prix = $cotisation->getPrixCotisation()*100;
            $em = $this->getDoctrine()->getManager();
            $em->persist($cotisation);
            $em->flush();
            $response = new Response();
            //$response = new CurlResponse();
            $actionMode = $cotisation->getVadsActionMode();
            //$captureDelay = $cotisation->getVadsCaptureDelay();
            $ctxMode = $cotisation->getCtxMode();
            $currency = $cotisation->getVadsCurrency();
            $pageAction = $cotisation->getVadsPageAction();
            //$paymentCards = $cotisation->getVadsPaymentCards();
            $paymentConfig = $cotisation->getVadsPaymentConfig();
            $siteId = $cotisation->getVadsSiteId();
            $transDate = $cotisation->getVadsTransDate();
            $transId = $cotisation->getVadsTransId();
            $version = $cotisation->getVadsVersion();
            //$certificate = $cotisation->getCertificate();
            $signature = $cotisation->getSignature();
            return $response = $httpClient->request('POST', 'https://paiement.systempay.fr/vads-payment/', [
                'body' => [
                    'vads_action_mode' =>  $actionMode,
                    'vads_amount' => $prix,
                    //'vads_capture_delay' => $captureDelay,
                    'vads_ctx_mode' => $ctxMode,
                    'vads_currency' => $currency,
                    'vads_page_action' => $pageAction,
                    //'vads_payment_cards' => $paymentCards,
                    'vads_payment_config' => $paymentConfig,
                    'vads_site_id' => $siteId,
                    'vads_trans_date' => $transDate,
                    'vads_trans_id' => $transId,
                    'vads_version' => $version,
                    //'vads_certificate' => $certificate,
                    'signature' => $signature
                ]
            ]);
            //echo $response->getContent();
        }

        return $this->render('cotisation/paiement.html.twig', [
            'form' => $form->createView(),
        ]);
    }

}

templates/cotisation/formCB.html.twig
{% extends 'user.html.twig' %}

{% block title %}paiement{% endblock %}

{% block body %}
<?php $toolbox = require "../config/config.php"; ?>
<form name="form" method="post" action="https://paiement.systempay.fr/vads-payment/">
    <div id="form">
        <input type="hidden" name="vads_action_mode" value="INTERACTIVE" />
        <div class="form-group">
            <label for="form_amount" class="required">Montant</label>
            <input type="text" id="form_amount" name="vads_amount" required class="form-control" value="{{cotisation.prixCotisation}}">
        </div>
        <input type="hidden" name="vads_ctx_mode" value="TEST" />
        <input type="hidden" id="form_capture_delay" name="vads_capture_delay" value="7">
        <input type="hidden" id="form_currency" name="vads_currency" value="978">
        <input type="hidden" name="vads_page_action" value="PAYMENT" />
        <input type="hidden" name="vads_payment_config" value="SINGLE" />
        <input type="hidden" name="vads_site_id" value="20169455" />
        <input type="hidden" name="vads_trans_date" value="<?php gmdate('YmdHis') ?>" />
        <input type="hidden" name="vads_trans_id" value="123456" />
        <input type="hidden" id="form_language" name="vads_language" value="fr">
        <input type="hidden" id="form_return_mode" name="vads_return_mode" value="GET">
        <input type="hidden" id="form_cust_id" name="vads_cust_id" value="{{cotisation.user}}">
        <input type="hidden" name="signature" value=""/>
        <div class="form-group">
           <input type="submit" name="payer" value="Payer"/>
        </div>
        <input type="hidden" id="form__token" name="form[_token]" value="X-ff0X8M8UhjdwamkRu4VR1YQaB4TaGjpuAFfriLxJs">
    </div>
</form>
{% endblock %}

templates/cotisation/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Cotisation{% endblock %}

{% block body %}

<div class="table-responsive">
    <table class="table striped centered align-middle">
		<thead>
			<tr>
				<th>Nom de la cotisation</th>
				<th>Type de cotisation</th>
                <th>Année</th>
                <th>Prix de la cotisation</th>
				<th>Moyen de paiement</th>
                <th>Payer</th>
			</tr>
		</thead>
		<tbody>
        {% for cotisation in cotisations %}
			<tr>
				<td>{{cotisation.libelleCotisation}}</td>
				<td>{{cotisation.typeCotisation}}</td>
				<td>{{cotisation.anneeCotisation}}</td>
                <td>{{cotisation.prixCotisation}}</td>
				<td>{{cotisation.moyenDePaiement}}</td>
				<td>
					<!--<a href="#" class="btn btn-primary"><i class="bi bi-eye-fill"></i></a>-->
                    <a href="{{ path("paiement_cotisation", {id: cotisation.id}) }}" class="btn btn-success"><i class="bi bi-credit-card"></i></a>
				</td>
			</tr>
        {% endfor %}
		</tbody>
	</table>

</div>
{% endblock %}

templates/cotisation/paiement.html.twig
{% extends 'user.html.twig' %}

{% block title %}Cotisation{% endblock %}

{% block body %}


<div>
    <h1>Cotisation</h1>
    {{form_start(form)}}
       <div class="col">
            {{form_label(form.libelleCotisation, 'Cotisation') }}
            {{form_widget(form.libelleCotisation) }}
            {{form_label(form.moyenDePaiement, 'Moyen de paiement') }}
            {{form_widget(form.moyenDePaiement)}}
            {{form_rest(form) }}
        </div>
</div>
{% endblock %}

templates/cotisation/show.html.twig
{% extends 'user.html.twig' %}

{% block title %}Cotisation {{ cotisation }}{% endblock %}

{% block body %}
	<h1>Cotisation</h1>
	<table class="table striped">
		<tr>
            <th>Nom de la cotisation</th>
			<td>{{cotisation.libelleCotisation}}</td>
        </tr>
        <tr>
            <th>Type de cotisation</th>
			<td>{{cotisation.typeCotisation}}</td>
        </tr>
        <tr>
            <th>Année cotisation</th>
            <td>{{cotisation.anneeCotisation}}</td>
        </tr>
        <tr>
            <th>Montant cotisation</th>
            <td>{{cotisation.prixCotisation}}</td>
        </tr>
        <tr>
            <th>Moyen de paiement</th>
            <td>{{cotisation.moyenDePaiement}}</td>
        </tr>
	</table>
{% endblock %}